#include "kommunikation.h"

void wait_for_command(void)
{
	//Warte auf einen Befehl
	while((USIC0_CH0->TRBSR & 0x00000008) != 0)
	{}
	
	
	befehlsverteiler((USIC0_CH0->OUTR & 0x0000FFFF));
}

void uart_poll(void)
{
	
	if((USIC0_CH0->TRBSR & 0x00000008) == 0)
	{
		befehlsverteiler((USIC0_CH0->OUTR & 0x0000FFFF));
	}
	
}

void befehlsverteiler(int befehl)
{
	switch(befehl)
	{
		//Connect Befehl
		case 1:
			uart_send(6);
			enable_sampling = false;
			status = 1;
			break;
		//Disconnect Befehl
		case 2:
			uart_send(6);
			status = 0;
			enable_sampling = false;
			break;
		//Read ID Befehl
		case 4:
			uart_send(reg_read(0));
			break;		
		//Start Sampling Befehl
		case 5:
			uart_send(6);
			enable_sampling = true;
			status = 2;
			break;
		//Stop Sampling Befehl
		case 6:
			enable_sampling = false;
			status = 1;
			break;
	}
}

void send_sample(void)
{
	//temporre Variable anlegen
	uint8_t temp = 0;
	
	//CS auf LOW
	P0_9_reset();
	
	SPI_send(0x12);
	
	//Zhler Variable anlegen
	uint8_t i = 0;
	
	//Schleife (wird 8 mal durchlaufen)
	while(i != 27)
	{
			
			temp = SPI_read();
			uart_send(temp);
		
		//Zhler hochzhlen
		i++;
	}
	
	
	
	
	//CS auf HIGH
	P0_9_set();
	
}
