#include "soft_spi.h"




void SPI_send(uint8_t wert)
{
	//Temporre Variable anlegen
	uint8_t temp;
	
	

	//Zhler Variable anlegen
	uint8_t i = 0;
	
	//Schleife (wird 8 mal durchlaufen)
	while(i != 8)
	{
		//SCLK auf HIGH
		P0_8_set();
		//Wert einen nach links Rotieren (so steht das MSB nun an LSB stelle)
		wert = (wert >> 7) | (wert << 1);
		//Maskieren, so dass nurnoch das LSB zu sehen ist
		temp = (wert & 0x01);
		//Auf MOSI ausgeben
		if(temp == 1)
		{
			P0_7_set();
		}
		else
		{
			P0_7_reset();
		}
		//SCLK zurck auf HIGH
		P0_8_reset();
		
		//Zhler hochzhlen
		i++;
	}
	
	P0_7_reset();
}



void SPI_send_8(uint8_t wert)
{
	
	//CS auf LOW
	P0_9_reset();
	
	//Wert ber SPI raussenden
	SPI_send(wert);
	
	//CS auf HIGH
	P0_9_set();
	
}

uint8_t SPI_read(void)
{
	//Temporre Variable anlegen
	uint8_t temp;
	
	//Variable fr den Wert anlegen
	uint8_t wert;

	//Zhler Variable anlegen
	uint8_t i = 0;
	
	//Schleife (wird 8 mal durchlaufen)
	while(i != 8)
	{
		//SCLK auf HIGH
		P0_8_set();
		
		//weiter drehen
		wert = (wert << 1);
		
		//MISO einlesen
		temp = P0_6_read();
		
		if(temp != 0)
		{
			wert = (wert | 0x01);
		}
		
		//SCLK zurck auf LOW
		P0_8_reset();
		
		//Zhler hochzhlen
		i++;
	}
	
	P0_7_reset();

	
	
	return(wert);
	
	
}





uint8_t reg_read (uint8_t addr)
{
	
	//CS auf LOW
	P0_9_reset();
	
	//Wert ber SPI raussenden
	SPI_send(0x20 | addr);
	
	//Wert ber SPI raussenden
	SPI_send(0);
	
	//Wert ber SPI lesen
	addr = SPI_read();
	
	//CS auf HIGH
	P0_9_set();
	
	
	return(addr);
	
	
}


void reg_write (uint8_t addr, uint8_t data)
{
	
	//CS auf LOW
	P0_9_reset();
	
	//Wert ber SPI raussenden
	SPI_send(0x40 | addr);
	
	//Wert ber SPI raussenden
	SPI_send(0);
	
	//Wert ber SPI raussenden
	SPI_send(data);
	
	//CS auf HIGH
	P0_9_set();
}
